=== src/Makefile ===
#################################################################################
#                Cameleon                                                       #
#                                                                               #
#    Copyright (C) 2004-2010 Institut National de Recherche en Informatique     #
#    et en Automatique. All rights reserved.                                    #
#                                                                               #
#    This program is free software; you can redistribute it and/or modify       #
#    it under the terms of the GNU Library General Public License as            #
#    published by the Free Software Foundation; either version 2 of the         #
#    License, or any later version.                                             #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Library General Public License for more details.                       #
#                                                                               #
#    You should have received a copy of the GNU Library General Public          #
#    License along with this program; if not, write to the Free Software        #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                   #
#    02111-1307  USA                                                            #
#                                                                               #
#    Contact: Maxence.Guesdon@inria.fr                                          #
#                                                                               #
#################################################################################

include ../master.Makefile

SYSTEM_INCLUDES= \
	-I +threads \
	-I +ocamldoc \
	-I ocaml/parsing \
	-I ocaml/typing \
	$(OCAML_DRIVER_INCLUDES) \
	-I ocaml/utils \
	$(PCRE_INCLUDES) \
	$(LABLGTK2_INCLUDES) \
	$(LABLGTKSOURCEVIEW_INCLUDES) \
	$(XMLLIGHT_INCLUDES)

MY_INCLUDES= \
	-I odot \
	-I okey \
	-I utils \
	-I odiff \
	-I tdl \
	-I rss \
	-I tmpl-engine \
	-I sqml \
	-I config_file \
	-I configwin \
	-I gtksv-utils \
	-I report \
	-I dbforge \
	-I ocamlcvs \
	-I editor \
	-I cameleon \
	-I camtop \
	-I custop \
	-I multiclip \
	-I plugins \
	-I snippets

INCLUDES= \
	$(SYSTEM_INCLUDES) \
	$(MY_INCLUDES)

MKCHAMO_INCLUDES= \
	-I +threads \
	-I +ocamldoc \
	$(OCAML_DRIVER_INCLUDES) \
	-I $(LIBDIR) \
	$(PCRE_INCLUDES) \
	$(LABLGTK2_INCLUDES) \
	$(LABLGTKSOURCEVIEW_INCLUDES) \
	$(XMLLIGHT_INCLUDES)

COMPFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)
LINKFLAGS_BYTE=$(INCLUDES)

#OCAMLPP=-pp "$(OCAMLBIN)/camlp4o "

TOOLS=$(REPORT) $(REPORT_GUI) $(TMPL_ENGINE) \
	$(DBFORGE) $(DBFORGE_GUI) \
	$(OCAMLCVS) $(TDL) $(TDL_EXPORT) $(TDL_HTML) $(TDL_SVN) \
	$(RSS) $(RSS_EXPORT)\
	$(EDITOR) $(CAMELEON) $(CAM_CONFIG) $(DOCBROWSER)
TOOLS_BYTE=$(REPORT_BYTE) $(REPORT_GUI_BYTE) \
	$(TMPL_ENGINE_BYTE) \
	$(DBFORGE_BYTE) $(DBFORGE_GUI_BYTE) \
	$(OCAMLCVS_BYTE) \
	$(TDL_BYTE) $(TDL_EXPORT_BYTE) $(TDL_HTML_BYTE) $(TDL_SVN_BYTE) \
	$(RSS_BYTE) $(RSS_EXPORT_BYTE) \
	$(EDITOR_BYTE) $(CAMELEON_BYTE) $(CAM_CONFIG_BYTE) $(DOCBROWSER_BYTE) $(CAMTOP)

UTILS=utils/gstuff.cmx \
	utils/gmylist.cmx \
	utils/gmytree.cmx \
	utils/gdir.cmx \
	utils/ffind.cmx \
	utils/dtypes.cmx
UTILS_BYTE=utils/gstuff.cmo \
	utils/gmylist.cmo \
	utils/gmytree.cmo \
	utils/gdir.cmo \
	utils/ffind.cmo \
	utils/dtypes.cmo

PLUGINS=plugins/test.cmo plugins/dep_view.cma

# Compilation
#############

# Cameleon
# files shared with editor
CAMELEON_SHARED_CMOFILES=\
	cameleon/cam_messages.cmo \
	cameleon/cam_config.cmo \
	cameleon/cam_dbg.cmo \
	cameleon/cam_misc.cmo \
	cameleon/cam_constant.cmo \
	cameleon/cam_rc.cmo \
	cameleon/cam_com_history.cmo \
	cameleon/cam_hooks.cmo \
	cameleon/cam_commands.cmo \
	cameleon/cam_log.cmo \
	cameleon/cam_args.cmo

CAMELEON_COMMON_CMOFILES=\
	$(EDITOR_COMMON_CMOFILES) \
	cameleon/cam_chamo.cmo \
	cameleon/cam_gui_base.cmo \
	cameleon/cam_gui.cmo \
	cameleon/cam_keymaps.cmo \
	cameleon/cam_view.cmo \
	cameleon/cam_dir_view.cmo \
	cameleon/cam_doc.cmo \
	cameleon/cam_doc_gui.cmo

PRE_CAMELEON_CMOFILES=$(CAMELEON_COMMON_CMOFILES) \
	cameleon/cam_minibuffer.cmo \
	cameleon/cam_files.cmo \
	cameleon/cam_cvs_view.cmo \
	cameleon/cam_files_view.cmo \
	cameleon/cam_modules_view.cmo \
	cameleon/cam_multiview.cmo \
	cameleon/cam_bbar.cmo \
	cameleon/cam_new_project.cmo \
	cameleon/cam_menus.cmo \
	cameleon/cam_server.cmo \
	cameleon/cam_plug.cmo \
	cameleon/cam_rss.cmo

CAMELEON_CMOFILES=$(PRE_CAMELEON_CMOFILES) \
	editor/ed_eval.cmo \
	cameleon/cam_plugins.cmo \
	cameleon/cam_main.cmo

CAMELEON_CMXFILES=$(PRE_CAMELEON_CMOFILES:.cmo=.cmx) \
	cameleon/cam_main.cmx

CAMELEON_CMIFILES= $(CAMELEON_CMOFILES:.cmo=.cmi)

CAM_CONFIG_CMOFILES=\
	cameleon/cam_installation.cmo \
	cameleon/cam_config.cmo \
	cameleon/cam_config_main.cmo

CAM_CONFIG_CMXFILES=$(CAM_CONFIG_CMOFILES:.cmo=.cmx)
CAM_CONFIG_CMIFILES=$(CAM_CONFIG_CMOFILES:.cmo=.cmi)

DOCBROWSER_CMOFILES=$(CAMELEON_COMMON_CMOFILES) \
	cameleon/cam_docbrowser.cmo

DOCBROWSER_CMXFILES= $(DOCBROWSER_CMOFILES:.cmo=.cmx)
DOCBROWSER_CMIFILES= $(DOCBROWSER_CMOFILES:.cmo=.cmi)

# Editor

EDITOR_COMMON_CMOFILES=\
	utils/dtypes.cmo \
	$(CAMELEON_SHARED_CMOFILES) \
	editor/ed_config.cmo \
	editor/ed_messages.cmo \
	editor/ed_prefs.cmo \
	editor/ed_gui_base.cmo \
	editor/ed_keymaps.cmo \
	editor/ed_gui_rc.cmo \
	editor/ed_bookmarks.cmo \
	editor/ed_fstack.cmo \
	editor/ed_sourceview_rc.cmo \
	editor/ed_minibuffer_rc.cmo \
	editor/ed_minibuffer.cmo \
	editor/ed_charsets.cmo \
	editor/ed_core_rc.cmo \
	editor/ed_outputs.cmo \
	editor/ed_misc.cmo \
	editor/ed_view_rc.cmo \
	editor/ed_view.cmo \
	editor/ed_multiclip_rc.cmo \
	editor/ed_multiclip.cmo \
	editor/ed_odoc_rc.cmo \
	editor/ed_odoc.cmo \
	editor/ed_tdl_rc.cmo \
	editor/ed_tdl.cmo \
	editor/ed_sourceview.cmo \
	editor/ed_sourceview_expand.cmo \
	editor/ed_ocamloutput.cmo \
	editor/ed_ocaml_lexer.cmo \
	editor/ed_mode_ocaml_rc.cmo \
	editor/ed_ocamlbuild.cmo \
	editor/ed_mode_ocaml.cmo \
	editor/ed_mode_makefile_rc.cmo \
	editor/ed_mode_makefile.cmo \
	editor/ed_mode_changelog_rc.cmo \
	editor/ed_mode_changelog.cmo \
	editor/ed_gui.cmo \
	editor/ed_layout.cmo

EDITOR_COMMON_CMIFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmi)
EDITOR_COMMON_CMXFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmx)

EDITOR_CMOFILES=$(EDITOR_COMMON_CMOFILES) \
	editor/ed_eval.cmo \
	editor/ed_main.cmo
EDITOR_CMXFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmx) editor/ed_main.cmx
EDITOR_CMIFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmi) editor/ed_main.cmi

LIBEDITOR=editor/chamo.cmxa
LIBEDITOR_A=$(LIBEDITOR:.cmxa=.a)

EDITOR_LIBS=$(LIBEDITOR) $(LIBEDITOR_A)

EDITOR_LINK_LIBS=str.cmxa unix.cmxa threads.cmxa xml-light.cmxa \
	lablgtk.cmxa lablglade.cmxa gtkThread.cmx gtkInit.cmx \
	okey.cmx config_file.cmx configwin.cmxa \
	utils/gmylist.cmx utils/gmytree.cmx \
	multiclip/multiclip.cmx multiclip/multiclip_gui.cmx \
	cameleon/cam_installation.cmx \
	tdl.cmxa tdl_gui.cmxa lablgtksourceview2.cmxa \
	$(LIBSVUTILS) odoc_info.cmxa \
	pcre.cmxa
EDITOR_LINK_LIBS_BYTE=str.cma unix.cma threads.cma xml-light.cma \
	toplevellib.cma \
	lablgtk.cma lablglade.cma gtkThread.cmo gtkInit.cmo \
	okey.cmo config_file.cmo configwin.cma \
	utils/gmylist.cmo utils/gmytree.cmo \
	multiclip/multiclip.cmo multiclip/multiclip_gui.cmo \
	cameleon/cam_installation.cmo \
	tdl.cma tdl_gui.cma lablgtksourceview2.cma \
	$(LIBSVUTILS_BYTE) odoc_info.cma \
	pcre.cma
MKCHAMO_LINK_LIBS=str.cmxa unix.cmxa threads.cmxa xml-light.cmxa \
	lablgtk.cmxa lablglade.cmxa gtkThread.cmx gtkInit.cmx \
	okey.cmx config_file.cmx configwin.cmxa \
	gmylist.cmx gmytree.cmx \
	multiclip.cmx multiclip_gui.cmx \
	cam_installation.cmx \
	tdl.cmxa tdl_gui.cmxa lablgtksourceview2.cmxa \
	gtksv_utils.cmx odoc_info.cmxa \
	pcre.cmxa

MKCHAMO_SCRIPT=editor/make_my_chamo
# Okey

LIBOKEY=okey/okey.cmx
LIBOKEY_BYTE=$(LIBOKEY:.cmx=.cmo)
LIBOKEY_CMI=$(LIBOKEY:.cmx=.cmi)
LIBOKEY_O=$(LIBOKEY:.cmx=.o)

OKEY_LIBS=$(LIBOKEY) $(LIBOKEY_BYTE) $(LIBOKEY_CMI) $(LIBOKEY_O)

# Odot

LIBODOT=odot/odot.cmxa
LIBODOT_BYTE=$(LIBODOT:.cmxa=.cma)
LIBODOT_CMI=$(LIBODOT:.cmxa=.cmi)
LIBODOT_A=$(LIBODOT:.cmxa=.a)
LIBODOT_VIEW=odot/odot_view.cmx
LIBODOT_VIEW_BYTE=$(LIBODOT_VIEW:.cmx=.cmo)
LIBODOT_VIEW_CMI=$(LIBODOT_VIEW:.cmx=.cmi)
LIBODOT_VIEW_O=$(LIBODOT_VIEW:.cmx=.o)
ODOT_LIBS=$(LIBODOT) $(LIBODOT_BYTE) $(LIBODOT_CMI) $(LIBODOT_A) \
	$(LIBODOT_VIEW) $(LIBODOT_VIEW_BYTE) $(LIBODOT_VIEW_CMI) $(LIBODOT_VIEW_O)



# Config_file

LIBCF=config_file/config_file.cmx
LIBCF_BYTE=$(LIBCF:.cmx=.cmo)
LIBCF_CMI=$(LIBCF:.cmx=.cmi)
LIBCF_O=$(LIBCF:.cmx=.o)

CF_LIBS=$(LIBCF) $(LIBCF_BYTE) $(LIBCF_CMI) $(LIBCF_O)


# Gtksv-utils

LIBSVUTILS=gtksv-utils/gtksv_utils.cmx
LIBSVUTILS_BYTE=$(LIBSVUTILS:.cmx=.cmo)
LIBSVUTILS_CMI=$(LIBSVUTILS:.cmx=.cmi)
LIBSVUTILS_O=$(LIBSVUTILS:.cmx=.o)

SVUTILS_LIBS=$(LIBSVUTILS) $(LIBSVUTILS_BYTE) $(LIBSVUTILS_CMI) $(LIBSVUTILS_O)

# Configwin

CW_COMMON_CMOFILES=\
	configwin/configwin_keys.cmo \
	configwin/configwin_types.cmo \
	configwin/configwin_messages.cmo \
	configwin/configwin_ihm.cmo

LIBCW_CMOFILES=$(CW_COMMON_CMOFILES) configwin/configwin.cmo
LIBCW_CMIFILES=$(LIBCW_CMOFILES:.cmo=.cmi)
LIBCW_CMXFILES=$(LIBCW_CMOFILES:.cmo=.cmx)

LIBCW=configwin/configwin.cmxa
LIBCW_BYTE=$(LIBCW:.cmxa=.cma)
LIBCW_CMI=$(LIBCW:.cmxa=.cmi)
LIBCW_A=$(LIBCW:.cmxa=.a)

CW_LIBS=$(LIBCW) $(LIBCW_BYTE) $(LIBCW_CMI) $(LIBCW_A)

# Tdl

TDL_COMMON_CMOFILES=\
	tdl/tdl_messages.cmo \
	tdl/tdl_date.cmo \
	tdl/tdl_types.cmo \
	tdl/tdl_io.cmo \
	tdl/tdl_filter.cmo \
	tdl/tdl_filter_parser.cmo \
	tdl/tdl_filter_lexer.cmo \
	tdl/tdl.cmo

LIBTDL_CMOFILES=$(TDL_COMMON_CMOFILES)
LIBTDL_CMIFILES=$(LIBTDL_CMOFILES:.cmo=.cmi)
LIBTDL_CMXFILES=$(LIBTDL_CMOFILES:.cmo=.cmx)

TDL_EXPORT_CMOFILES=tdl/tdl_export.cmo
TDL_EXPORT_CMIFILES=$(TDL_EXPORT_CMOFILES:.cmo=.cmi)
TDL_EXPORT_CMXFILES=$(TDL_EXPORT_CMOFILES:.cmo=.cmx)

TDL_SVN_CMOFILES=tdl/tdl_svn.cmo
TDL_SVN_CMIFILES=$(TDL_SVN_CMOFILES:.cmo=.cmi)
TDL_SVN_CMXFILES=$(TDL_SVN_CMOFILES:.cmo=.cmx)

TDL_HTML_CMOFILES=tdl/tdl2html.cmo
TDL_HTML_CMIFILES=$(TDL_HTML_CMOFILES:.cmo=.cmi)
TDL_HTML_CMXFILES=$(TDL_HTML_CMOFILES:.cmo=.cmx)

LIBTDL=tdl/tdl.cmxa
LIBTDL_BYTE=$(LIBTDL:.cmxa=.cma)
LIBTDL_CMI=$(LIBTDL:.cmxa=.cmi)
LIBTDL_A=$(LIBTDL:.cmxa=.a)

LIBTDL_GUI_CMOFILES=\
	tdl/tdl_gui_rc.cmo \
	tdl/tdl_gui_base.cmo \
	tdl/tdl_gui.cmo
LIBTDL_GUI_CMIFILES=$(LIBTDL_GUI_CMOFILES:.cmo=.cmi)
LIBTDL_GUI_CMXFILES=$(LIBTDL_GUI_CMOFILES:.cmo=.cmx)

LIBTDL_GUI=tdl/tdl_gui.cmxa
LIBTDL_GUI_BYTE=$(LIBTDL_GUI:.cmxa=.cma)
LIBTDL_GUI_CMI=$(LIBTDL_GUI:.cmxa=.cmi)
LIBTDL_GUI_A=$(LIBTDL_GUI:.cmxa=.a)

TDL_CMOFILES=tdl/tdl_main.cmo
TDL_CMIFILES=$(TDL_CMOFILES:.cmo=.cmi)
TDL_CMXFILES=$(TDL_CMOFILES:.cmo=.cmx)

ODOC_TDL_CMOFILES=$(TDL_COMMON_CMOFILES) tdl/odoc_tdl.cmo
ODOC_TDL=tdl/odoc_tdl.cma
ODOC_TDL_CMI=$(ODOC_TDL:.cma=.cmi)

TDL_LIBS=$(LIBTDL) $(LIBTDL_BYTE) $(LIBTDL_CMI) $(LIBTDL_A) \
	$(LIBTDL_GUI) $(LIBTDL_GUI_BYTE) $(LIBTDL_GUI_CMI) $(LIBTDL_GUI_A)

# RSS

RSS_COMMON_CMOFILES=\
	rss/rss_messages.cmo \
	rss/rss_date.cmo \
	rss/rss_types.cmo \
	rss/rss_io.cmo \
	rss/rss.cmo

LIBRSS_CMOFILES=$(RSS_COMMON_CMOFILES)
LIBRSS_CMIFILES=$(LIBRSS_CMOFILES:.cmo=.cmi)
LIBRSS_CMXFILES=$(LIBRSS_CMOFILES:.cmo=.cmx)

LIBRSS=rss/rss.cmxa
LIBRSS_BYTE=$(LIBRSS:.cmxa=.cma)
LIBRSS_CMI=$(LIBRSS:.cmxa=.cmi)
LIBRSS_A=$(LIBRSS:.cmxa=.a)

LIBRSS_GUI_CMOFILES=\
	rss/rss_gui_base.cmo \
	rss/rss_gui.cmo
LIBRSS_GUI_CMIFILES=$(LIBRSS_GUI_CMOFILES:.cmo=.cmi)
LIBRSS_GUI_CMXFILES=$(LIBRSS_GUI_CMOFILES:.cmo=.cmx)

LIBRSS_GUI=rss/rss_gui.cmxa
LIBRSS_GUI_BYTE=$(LIBRSS_GUI:.cmxa=.cma)
LIBRSS_GUI_CMI=$(LIBRSS_GUI:.cmxa=.cmi)
LIBRSS_GUI_A=$(LIBRSS_GUI:.cmxa=.a)

RSS_CMOFILES=rss/rss_gui_main.cmo
RSS_CMIFILES=$(RSS_CMOFILES:.cmo=.cmi)
RSS_CMXFILES=$(RSS_CMOFILES:.cmo=.cmx)
