=== src/dbforge/translate/Makefile ===
##########################################################################
#                   Cameleon                                             #
#                                                                        #
#      Copyright (C) 2002 Institut National de Recherche en Informatique et   #
#      en Automatique. All rights reserved.                              #
#                                                                        #
#      This program is free software; you can redistribute it and/or modify  #
#      it under the terms of the GNU General Public License as published by  #
#      the Free Software Foundation; either version 2 of the License, or  #
#      any later version.                                                #
#                                                                        #
#      This program is distributed in the hope that it will be useful,   #
#      but WITHOUT ANY WARRANTY; without even the implied warranty of    #
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     #
#      GNU General Public License for more details.                      #
#                                                                        #
#      You should have received a copy of the GNU General Public License  #
#      along with this program; if not, write to the Free Software       #
#      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA          #
#      02111-1307  USA                                                   #
#                                                                        #
#      Contact: Maxence.Guesdon@inria.fr                                #
##########################################################################

include ../../master.Makefile

CMOFILES=../dbf_messages.cmo \
	dbft_documentIO.cmo\
	dbft_parser.cmo\
	dbft_lexer.cmo\
	../dbf_types.cmo\
	../dbf_misc.cmo\
	dbft.cmo

CMXFILES=$(CMOFILES:.cmo=.cmx)
CMIFILES=$(CMOFILES:.cmo=.cmi)

EXE=dbftrans

LINKFLAGS=-I ../ocamlsql -I $(ROOT)/ioxml -I +camlp4

byte: $(EXE) 
all:byte opt 
opt: $(EXE_OPT) 
debug: 
	$(MAKE) OCAMLPP=""

LIBS=unix.cma str.cma $(LIB_OCAMLSQL) gramlib.cma $(ROOT)/ioxml/ioXML.cmo
LIBS_OPT=unix.cmxa str.cmxa $(LIB_OCAMLSQL_OPT) gramlib.cmxa $(ROOT)/ioxml/ioXML.cmx

$(EXE): $(CMIFILES) $(CMOFILES) 
	$(OCAMLC) -custom -o $@ $(LINKFLAGS) $(LIBS) $(CMOFILES) 

$(EXE_OPT): $(CMXFILES) 
	$(OCAMLOPT) -o $@ $(LINKFLAGS) $(LIBS_OPT) $(CMXFILES) 



# backup, clean and depend :
############################

clean:: 
	@$(RM) -f *~ \#*\#
	@$(RM) $(EXE) $(EXE_OPT)
	@$(RM) *.cmo *.cmi *.cmx *.cma *.cmxa *.a *.o 
	@$(RM) dbft_parser.output dbft_parser.ml dbft_parser.mli

distclean:: clean

.depend depend::
	$(OCAMLDEP) *.ml *.mli > .depend

dummy:

include .depend
