=== debian/changelog ===
cameleon (1.9.20-1build1) oneiric; urgency=low

  * Rebuild to pick up ocaml fixes on armel.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 24 Aug 2011 16:34:19 -0600

cameleon (1.9.20-1) unstable; urgency=low

  * New upstream release:
    - compatible with OCaml 3.12.0 (Closes: #580094)
  * debian/control:
    - remove Stefano from Uploaders
    - clean up Provides/Conflicts/Replaces
    - bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Tue, 19 Apr 2011 09:57:48 +0200
