=== debian/control ===
Source: cameleon
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Sylvain Le Gall <gildor@debian.org>,
 Samuel Mimram <smimram@debian.org>
Build-Depends:
 patchutils (>= 0.2.25),
 cdbs (>= 0.4.27),
 ocaml-nox (>= 3.12),
 po4a, docbook-xml (>= 4.4), docbook-xsl, libxml2-utils, xsltproc,
 debhelper (>= 7),
 dh-ocaml (>= 0.9.1~),
 camlp4,
 ocaml-findlib (>= 1.2.5),
 liblablgtk2-ocaml-dev (>= 2.14),
 libxml-light-ocaml-dev (>= 2.2-12~),
 liblablgtksourceview2-ocaml-dev,
 libpcre-ocaml-dev (>= 6.0.1-2~),
 imagemagick,
 docbook-ebnf
Standards-Version: 3.9.2
Homepage: http://home.gna.org/cameleon/
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cameleon.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cameleon.git

Package: cameleon
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: cameleon-doc
Description: integrated development environment for OCaml
 Cameleon is a set of tools and libraries put together to create an
 integrated development environment for the OCaml programming language.
 .
 Its main features are :
  - graphical user interface,
  - configuration management based on CVS,
  - easy access to and browsing of documentation,
  - various editors, according to customizable file types,
  - use of plug-ins to define new features,
  - highly customizable interface (menus, toolbar, keyboard shortcuts).
 .
 Tools shipped are :
  - Chamo, a source code editor based on the GtkSourceView widget with some
    emacs-like functionality,
  - DBforge, a tool to describe database schemas and generate OCaml code to
    access these databases,
  - OCamlCVS, a graphical front end for the CVS configuration management
    utility,
  - Report, a tool aims to make generation of XML documents from OCaml
    applications easier,

Package: cameleon-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for Cameleon
 It contains documentation build with Cameleon:
  - Cameleon reference manual
  - Cameleon user manual,
 .
 Documentation can be in HTML, Postscript or odoc formats.

Package: libcameleon-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocaml-findlib, cameleon-doc
Provides: ${ocaml:Provides}
Description: libraries from Cameleon
 It contains the libraries built with Cameleon:
  - Config_file, create configuration files,
  - Configwin, build configuration or input windows in LablGTK,
  - Odiff, print and parse differences between files or strings, in the diff
    utility format,
  - Odot, parse and print Graphviz dot files,
  - Okey, add handlers to key press events in LablGTK,
  - Tdl, represent, store and read TODO lists in XML files,
